function varargout = o_t_TraceFcn(varargin)
% O_T_TRACEFCN Application M-file for o_t_TraceFcn.fig
%    FIG = O_T_TRACEFCN launch o_t_TraceFcn GUI.
%    O_T_TRACEFCN('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 30-Sep-2002 21:59:24

global HstG d_oph h_oph t_oph p_oph HstIni HstLast HstS HstIniS HstLastS BinsXIni BinsYIni BinsZIni	BinsXLast BinsYLast BinsZLast...
	HstT BinsT BinsXT BinsYT BinsZT EnblSnd LastFigure CrntPath d_options h_options t_options p_options  h_pdfX h_pdfY h_pdfZ h_o_t_Preview
dbstop if error
t_options=[];	%clear old options content

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Use system color scheme for figure:
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.




% --------------------------------------------------------------------
function varargout = o_t_DataSource_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_Start_Callback(h, eventdata, handles, varargin)
hcb t_trace

% --------------------------------------------------------------------
function varargout = o_t_FileListLoad_Callback(h, eventdata, handles, varargin)
global t_oph CrntPath
s=[];
ft='*.txr';	%Initializinf full filename, filename and extension martixes
[s,v]=uigetfiles(ft,'Select the trace file(s):');
CrntPath=v;
if ~isempty(s)
    cd(v);
    set(findobj(t_oph,'Tag','o_t_FileList'),'String',s);
    set(findobj(t_oph,'Tag','o_t_FileList'),'Value',1);
    set(findobj(t_oph,'Tag','o_t_FileInfo'),'String',s{1});
    set(findobj(t_oph,'Tag','o_t_DataSource'),'Value',2);
end
% --------------------------------------------------------------------
function varargout = o_t_FileListAdd_Callback(h, eventdata, handles, varargin)
global t_oph CrntPath
s_old=get(findobj(t_oph,'Tag','o_t_FileList'),'String');	%Remember old file list
o_t_FileListLoad_Callback
s=get(findobj(t_oph,'Tag','o_t_FileList'),'String');	%Get file list
for i=1:length(s)	%Combine file lists
	s_old{end+1}=s{i};
end
set(findobj(t_oph,'Tag','o_t_FileList'),'String',s_old);	
set(findobj(t_oph,'Tag','o_t_FileList'),'Value',1);
set(findobj(t_oph,'Tag','o_t_FileInfo'),'String',s_old{1});

% --------------------------------------------------------------------
function varargout = o_t_FileListDelete_Callback(h, eventdata, handles, varargin)
global t_oph CrntPath
s=get(findobj(t_oph,'Tag','o_t_FileList'),'String');	%
v=get(findobj(t_oph,'Tag','o_t_FileList'),'Value');
if  ~iscell(s)|length(s)==1  %the list will be empty
    set(findobj(t_oph,'Tag','o_t_FileList'),'Value',1);
    set(findobj(t_oph,'Tag','o_t_FileList'),'String',{'(None)'});
    set(findobj(t_oph,'Tag','o_t_FileInfo'),'String','(None)');
else
    for i=1:(v-1)
        sn{i}=s{i};
    end
    for i=(v+1):(length(s))
        sn{i-1}=s{i};
    end
    set(findobj(t_oph,'Tag','o_t_FileList'),'String',sn);	%
    set(findobj(t_oph,'Tag','o_t_FileList'),'Value',max(1,(v-1)));
    set(findobj(t_oph,'Tag','o_t_FileInfo'),'String',sn{max(1,(v-1))});
end

% --------------------------------------------------------------------
function varargout = o_t_FileListClear_Callback(h, eventdata, handles, varargin)
global t_oph CrntPath
set(findobj(t_oph,'Tag','o_t_FileList'),'Value',1);
set(findobj(t_oph,'Tag','o_t_FileList'),'String',{'(None)'});
set(findobj(t_oph,'Tag','o_t_FileInfo'),'String','(None)');
set(findobj(t_oph,'Tag','o_t_DataSource'),'Value',1);

% --------------------------------------------------------------------
function varargout = o_t_FileList_Callback(h, eventdata, handles, varargin)
global t_oph CrntPath
s=get(findobj(t_oph,'Tag','o_t_FileList'),'String');
v=get(findobj(t_oph,'Tag','o_t_FileList'),'Value');
set(findobj(t_oph,'Tag','o_t_FileInfo'),'String',s{v});

% --------------------------------------------------------------------
function varargout = o_t_DistrType_Callback(h, eventdata, handles, varargin)
global t_oph
s=get(findobj(t_oph,'Tag','o_t_DistrType'),'String');
v=get(findobj(t_oph,'Tag','o_t_DistrType'),'Value');
DistrType=s{v};
switch DistrType
case 'Normal distribution'
    set(findobj(t_oph,'Tag','o_t_DistrCustom'),'String','(None)');
case 'Custom distribution'
    set(findobj(t_oph,'Tag','o_t_DistrCustom'),'String','0 1 5 7 5 1 0');
end

% --------------------------------------------------------------------
function varargout = o_t_DistrLoad_Callback(h, eventdata, handles, varargin)
global t_oph
s=[];
ft='*.txt';	%Initializinf full filename, filename and extension martixes
[s,v]=uigetfiles(ft,'Select the distribution file:');
if ~isempty(s)
    cd(v);
    fid=fopen(s{1});
    t=fgetl(fid);    %Text with distribution fromthe file. It's supposed to be a 1-line file with values separated by spaces. Full distribution (both sides)
    fclose(fid);
    set(findobj(t_oph,'Tag','o_t_DistrCustom'),'String',t);
    set(findobj(t_oph,'Tag','o_t_DistrType'),'Value',2);    %Set distribution type to "Custom"
end


% --------------------------------------------------------------------
function varargout = o_t_DistrCustom_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_HistType_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_ScaleMode_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_DistrNum_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_FitLoad_Callback(h, eventdata, handles, varargin)
global t_oph CrntPath
s=[];
ft='*.txt';	%Initializinf full filename, filename and extension martixes
[s,v]=uigetfiles(ft,'Select the distributions parameters file:');
CrntPath=v;
if ~isempty(s)
	cd(v);
	FitParameters=multifit_load(s{1});
	set(findobj(t_oph,'Tag','o_t_DistrNum'),'String',num2str(size(FitParameters,2)));
	
	MeanFitList=num2cell(FitParameters(1,:));
	set(findobj(t_oph,'Tag','o_t_MeanFitList'),'String',MeanFitList);
	set(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value',1);
	set(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String',MeanFitList{1});
	
	StdFitList=num2cell(FitParameters(2,:));
	set(findobj(t_oph,'Tag','o_t_StdFitList'),'String',StdFitList);
	set(findobj(t_oph,'Tag','o_t_StdFitList'),'Value',1);
	set(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String',StdFitList{1});
	
	AmplFitList=num2cell(FitParameters(3,:));
	set(findobj(t_oph,'Tag','o_t_AmplFitList'),'String',AmplFitList);
	set(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value',1);
	set(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String',AmplFitList{1});
	
	
end

% --------------------------------------------------------------------
function varargout = o_t_FitSave_Callback(h, eventdata, handles, varargin)
global HstG d_oph h_oph t_oph p_oph HstIni HstLast HstS HstIniS HstLastS BinsXIni BinsYIni BinsZIni	BinsXLast BinsYLast BinsZLast...
	HstT BinsT BinsXT BinsYT BinsZT EnblSnd LastFigure CrntPath d_options h_options t_options p_options  h_pdfX h_pdfY h_pdfZ h_o_t_Preview

FitPreview=get(findobj(t_oph,'Tag','o_t_FitPreview'),'Value');
%============ read settings and values from the input forms
t_s=get(findobj(t_oph,'Tag','o_t_DataSource'),'String');	%Source of histogram to make fit
DataSource=t_s{get(findobj(t_oph,'Tag','o_t_DataSource'),'Value')};	%Source of histogram to make fit
FileList=get(findobj(t_oph,'Tag','o_t_FileList'),'String');	%list of files with Source data of histogram to make fit
t_s=get(findobj(t_oph,'Tag','o_t_ScaleMode'),'String');	%%Mode of scaling and weighting for difference calculation
ScaleMode=t_s{get(findobj(t_oph,'Tag','o_t_ScaleMode'),'Value')};	%%Mode of scaling and weighting for difference calculation
DistrNum=eval(['0',get(findobj(t_oph,'Tag','o_t_DistrNum'),'String')]);	%number of distributions used to fit the histogram
t_s=get(findobj(t_oph,'Tag','o_t_DistrType'),'String');	%Type of distribution to use to fit - normal or custom
DistrType=t_s{get(findobj(t_oph,'Tag','o_t_DistrType'),'Value')};	%Type of distribution to use to fit - normal or custom
DistrCustom=get(findobj(t_oph,'Tag','o_t_DistrCustom'),'String');	%Custom distribution to use to fit

if ~iscell(FileList)    %there is only one file
	FileList={FileList};
end    %there is only one file

MeanFitList=[];
t={};
t=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
if ~iscell(t)   %there is one line
	MeanFitList=eval(t);
else   %there are many lines
	for i=1:length(t)   %Convert list to numbers
		MeanFitList(i)=eval(t{i});
	end
end   %there is one line

AmplFitList=[];
t={};
t=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'String');
if ~iscell(t)   %there is one line
	AmplFitList=eval(t);
else   %there are many lines
	for i=1:length(t)   %Convert list to numbers
		AmplFitList(i)=eval(t{i});
	end
end   %there is one line

StdFitList=[];
t={};
t=get(findobj(t_oph,'Tag','o_t_StdFitList'),'String');
if ~iscell(t)   %there is one line
	StdFitList=eval(t);
else   %there are many lines
	for i=1:length(t)   %Convert list to numbers
		StdFitList(i)=eval(t{i});
	end
end   %there is one line

if DataSource==1    %Histogram in file(s)
	ft='*.txr';	%Initializing full filename, filename and extension martixes
	ft=ft(2:end);
	FileList{i}=[FileList{i}(1:(findstr(FileList{i},ft)-1))];
	FileName=FileList{i};
	[HstT,BinsT]=trcopen(FileName);	%open histogram file function
	LabelAdd=FileName;
else
	LabelAdd=get(findobj(1,'Tag','t_file'),'String');
end    %Histogram in file(s)


%================= calculating fit
%calculate fitted distribution
FitParameters=MeanFitList;
FitParameters(2,:)=StdFitList;
FitParameters(3,:)=AmplFitList;
HstFit=zeros(size(HstT));	%Initialize fitted distribution
MinBins=min(BinsT); MaxBins=max(BinsT);
for i=1:DistrNum	%cycle through separate distributions to add them
	switch DistrType	%type of distributtions used for fitting
	case 'Normal distribution'
		BorderProb=FitParameters(3,i)*normcdf(BinsT,FitParameters(1,i),FitParameters(2,i));	%CDF probabilities on the borders of the bins
	end	%type of distributtions used for fitting
	HstFit=HstFit+(BorderProb(2:end)-BorderProb(1:(end-1)));	%probabilities to fit into the bin
end	%cycle through separate distributions to add them
HstTout=HstT/sum(HstT);
%HstFit=HstTout/2;


%================= Saving block
%*** Creation bins' bunradies for plotting

switch ScaleMode	%Mode of scaling and weighting for difference calculation
case 'Linear'	%Need logscale
	HstToutp=log10([loghst(HstTout)]);
	HstFitp=log10([loghst(HstFit)]);
	LabelAdd=['Log of ', LabelAdd];
case {'Log' 'LogMaxWeighted'}
	HstToutp=log10([loghst(HstTout)]);
	HstFitp=log10([loghst(HstFit)]);
	LabelAdd=['Log of ', LabelAdd];
end		%Mode of scaling and weighting for difference calculation

trcsave([LabelAdd,'_multifit-ini'],HstTout,BinsT);	%save initial histogram
trcsave([LabelAdd,'_multifit-fit'],HstFit,BinsT);	%save fitted histogram
multifit_save(LabelAdd,FitParameters);	%Save output parameters of the fit

% --------------------------------------------------------------------
function varargout = o_t_FitPreview_Callback(h, eventdata, handles, varargin)	%Plot preview of the fit and the initial histogram
global HstG d_oph h_oph t_oph p_oph HstIni HstLast HstS HstIniS HstLastS BinsXIni BinsYIni BinsZIni	BinsXLast BinsYLast BinsZLast...
	HstT BinsT BinsXT BinsYT BinsZT EnblSnd LastFigure CrntPath d_options h_options t_options p_options  h_pdfX h_pdfY h_pdfZ h_o_t_Preview

FitPreview=get(findobj(t_oph,'Tag','o_t_FitPreview'),'Value');
if FitPreview==1	%Plot preview of the fit and the initial histogram
	%============ read settings and values from the input forms
	t_s=get(findobj(t_oph,'Tag','o_t_DataSource'),'String');	%Source of histogram to make fit
	DataSource=t_s{get(findobj(t_oph,'Tag','o_t_DataSource'),'Value')};	%Source of histogram to make fit
	FileList=get(findobj(t_oph,'Tag','o_t_FileList'),'String');	%list of files with Source data of histogram to make fit
	t_s=get(findobj(t_oph,'Tag','o_t_ScaleMode'),'String');	%%Mode of scaling and weighting for difference calculation
	ScaleMode=t_s{get(findobj(t_oph,'Tag','o_t_ScaleMode'),'Value')};	%%Mode of scaling and weighting for difference calculation
	DistrNum=eval(['0',get(findobj(t_oph,'Tag','o_t_DistrNum'),'String')]);	%number of distributions used to fit the histogram
	t_s=get(findobj(t_oph,'Tag','o_t_DistrType'),'String');	%Type of distribution to use to fit - normal or custom
	DistrType=t_s{get(findobj(t_oph,'Tag','o_t_DistrType'),'Value')};	%Type of distribution to use to fit - normal or custom
	DistrCustom=get(findobj(t_oph,'Tag','o_t_DistrCustom'),'String');	%Custom distribution to use to fit

	if ~iscell(FileList)    %there is only one file
		FileList={FileList};
	end    %there is only one file
	
	MeanFitList=[];
	t={};
	t=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
	if ~iscell(t)   %there is one line
		MeanFitList=eval(t);
	else   %there are many lines
		for i=1:length(t)   %Convert list to numbers
			MeanFitList(i)=eval(t{i});
		end
	end   %there is one line
	
	AmplFitList=[];
	t={};
	t=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'String');
	if ~iscell(t)   %there is one line
		AmplFitList=eval(t);
	else   %there are many lines
		for i=1:length(t)   %Convert list to numbers
			AmplFitList(i)=eval(t{i});
		end
	end   %there is one line
	
	StdFitList=[];
	t={};
	t=get(findobj(t_oph,'Tag','o_t_StdFitList'),'String');
	if ~iscell(t)   %there is one line
		StdFitList=eval(t);
	else   %there are many lines
		for i=1:length(t)   %Convert list to numbers
			StdFitList(i)=eval(t{i});
		end
	end   %there is one line
	
	switch DataSource	%Source of histogram data to fit - current histogram trace in memory or file
	case 'Data source: File'    %Histogram in file(s)
		ft='*.txr';	%Initializing full filename, filename and extension martixes
		ft=ft(2:end);
		i=1;
		FileList{i}=[FileList{i}(1:(findstr(FileList{i},ft)-1))];
		FileName=FileList{i};
		[HstT,BinsT]=trcopen(FileName);	%open histogram file function
		LabelAdd=FileName;
	case 'Data source: Current Histogram in Memory'
		LabelAdd=get(findobj(1,'Tag','t_file'),'String');
	end    %Histogram in file(s)
	
	
	%================= calculating fit
	%calculate fitted distribution
	FitParameters=MeanFitList;
	FitParameters(2,:)=StdFitList;
	FitParameters(3,:)=AmplFitList;
	HstFit=zeros(size(HstT));	%Initialize fitted distribution
	MinBins=min(BinsT); MaxBins=max(BinsT);
	for i=1:DistrNum	%cycle through separate distributions to add them
		switch DistrType	%type of distributtions used for fitting
		case 'Normal distribution'
			BorderProb=FitParameters(3,i)*normcdf(BinsT,FitParameters(1,i),FitParameters(2,i));	%CDF probabilities on the borders of the bins
		end	%type of distributtions used for fitting
		HstFit=HstFit+(BorderProb(2:end)-BorderProb(1:(end-1)));	%probabilities to fit into the bin
	end	%cycle through separate distributions to add them
	HstTout=HstT/sum(HstT);
	%HstFit=HstTout/2;
	
	
	%================= Plotting block
	%*** Creation bins' boundaries for plotting
	BinsTp=[];
	for i=1:(length(BinsT)-1)
		BinsTp(i)=(BinsT(i)+BinsT(i+1))/2;	%Assignin a bin boundaries mean as a plot bin value
	end
	Add=[];
	for i=1:DistrNum	%cycle through distributions
		BorderProb=FitParameters(3,i)*normcdf(BinsT,FitParameters(1,i),FitParameters(2,i));	%CDF probabilities on the borders of the bins
		Add(1:length(BinsTp),i)=(BorderProb(2:end)-BorderProb(1:(end-1)));
	end	%cycle through distributions
	
	switch ScaleMode	%Mode of scaling and weighting for difference calculation
	case 'Linear'	%Need logscale
		HstToutp=log10([loghst(HstTout)]);
		HstFitp=log10([loghst(HstFit)]);
		Add=log10([loghst(Add)]);
		LabelAdd=['Log of ', LabelAdd];
	case {'Log' 'LogMaxWeighted'}
		HstToutp=log10([loghst(HstTout)]);
		HstFitp=log10([loghst(HstFit)]);
		Add=log10([loghst(Add)]);
		LabelAdd=['Log of ', LabelAdd];
	end		%Mode of scaling and weighting for difference calculation
	
	if exist('h_o_t_Preview')~=1|isempty(h_o_t_Preview)	%there is no preview
		h_o_t_Preview=figure;
	end
	
	hp=plot(BinsTp,HstToutp,'Color','blue','LineWidth',2);
	%set(gca,'YLimMode','manual');
	ylimValue=ylim;
	hold on;
	hp=plot(BinsTp,HstFitp,'Color','red','LineWidth',2);
	hp=plot(BinsTp,Add,'m');
	set(gca,'Title',text('String',LabelAdd));
	ylim(ylimValue);
	XTick=get(gca,'XTick'); set(gca,'XTick',min(XTick):0.1:max(XTick));	%Make X-axis tick labels with 0.1 step
	set(gca,'XGrid','On');
	set(gca,'YGrid','On');
	hold off;
else	%Clear preview
	if exist('h_o_t_Preview')==1&size(h_o_t_Preview)>0; try; close(h_o_t_Preview); end; end
	h_o_t_Preview=[];
	clear h_o_t_Preview
end	%Plot preview of the fit and the initial histogram


% --------------------------------------------------------------------
function varargout = o_t_MeanFit_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_AmplFit_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_StdFit_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_MeanFitOpt_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_AmplFitOpt_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_StdFitOpt_Callback(h, eventdata, handles, varargin)
global t_oph

% --------------------------------------------------------------------
function varargout = o_t_MeanFitReset_Callback(h, eventdata, handles, varargin)
global t_oph
DistrNum=eval(['0',get(findobj(t_oph,'Tag','o_t_DistrNum'),'String')]);	%Number of distributions
MinBins=-0.2;	MaxBins=1.2;	%Supposed minimal and maximal bins for possible mean positions
MeanGuessStep=(MaxBins-MinBins)/(DistrNum+1);
MeanGuess=(MinBins+MeanGuessStep):MeanGuessStep:(MaxBins-MeanGuessStep);
MeanFitList=num2cell(MeanGuess);
set(findobj(t_oph,'Tag','o_t_MeanFitList'),'String',MeanFitList)
set(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value',1)
set(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String',MeanFitList{1})
set(findobj(t_oph,'Tag','o_t_MeanFitN'),'String','1');
% StdGuess=MeanGuessStep/4;
% AmplGuess=1/DistrNum;


% --------------------------------------------------------------------
function varargout = o_t_MeanFitAdd_Callback(h, eventdata, handles, varargin)
global t_oph
t={};
t=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
v=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value');
for i=1:length(t)
    Bins(i)=eval(t{i});
end
Bins=[Bins([1:v-1]),(Bins(max(1,(v-1)))+Bins(min(v,end)))/2, Bins([v:end])];
t={};
for i=1:length(Bins)
    t{i}=Bins(i);
end
set(findobj(t_oph,'Tag','o_t_MeanFitList'),'String',t);
set(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value',v);
set(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String',t{v});

% --------------------------------------------------------------------
function varargout = o_t_MeanFitDelete_Callback(h, eventdata, handles, varargin)
global t_oph
t={};
t=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
if length(t)>1
    v=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value');
    for i=1:length(t)
        Bins(i)=eval(t{i});
    end
    Bins=Bins([1:(v-1),(v+1):end]);
    t={};
    for i=1:length(Bins)
        t{i}=Bins(i);
    end
    v=max(1,(v-1));
    set(findobj(t_oph,'Tag','o_t_MeanFitList'),'String',t);
    set(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value',v);
    set(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String',t{v});
end

% --------------------------------------------------------------------
function varargout = o_t_MeanFitEdit_Callback(h, eventdata, handles, varargin)
global t_oph
s=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
v=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value');
sn=get(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String');
s{v}=sn;
set(findobj(t_oph,'Tag','o_t_MeanFitList'),'String',s);
o_t_TraceFcn('o_t_FitPreview_Callback');	%Refresh fit preview, if the option is checked

% --------------------------------------------------------------------
function varargout = o_t_AmplFitReset_Callback(h, eventdata, handles, varargin)
global t_oph
global t_oph
DistrNum=eval(['0',get(findobj(t_oph,'Tag','o_t_DistrNum'),'String')]);	%Number of distributions
for i=1:DistrNum    %cycle through the distributions
    AmplFitList{i}=1/DistrNum;
end    %cycle through the distributions

set(findobj(t_oph,'Tag','o_t_AmplFitList'),'String',AmplFitList)
set(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value',1)
set(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String',AmplFitList{1})
set(findobj(t_oph,'Tag','o_t_AmplFitN'),'String','1');


% --------------------------------------------------------------------
function varargout = o_t_AmplFitAdd_Callback(h, eventdata, handles, varargin)
global t_oph
t={};
t=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'String');
v=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value');
for i=1:length(t)
    Bins(i)=eval(t{i});
end
Bins=[Bins([1:v-1]),(Bins(max(1,(v-1)))+Bins(min(v,end)))/2, Bins([v:end])];
t={};
for i=1:length(Bins)
    t{i}=Bins(i);
end
set(findobj(t_oph,'Tag','o_t_AmplFitList'),'String',t);
set(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value',v);
set(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String',t{v});

% --------------------------------------------------------------------
function varargout = o_t_AmplFitDelete_Callback(h, eventdata, handles, varargin)
global t_oph
t={};
t=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'String');
if length(t)>1
    v=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value');
    for i=1:length(t)
        Bins(i)=eval(t{i});
    end
    Bins=Bins([1:(v-1),(v+1):end]);
    t={};
    for i=1:length(Bins)
        t{i}=Bins(i);
    end
    v=max(1,(v-1));
    set(findobj(t_oph,'Tag','o_t_AmplFitList'),'String',t);
    set(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value',v);
    set(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String',t{v});
end

% --------------------------------------------------------------------
function varargout = o_t_AmplFitEdit_Callback(h, eventdata, handles, varargin)
global t_oph
s=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'String');
v=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value');
sn=get(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String');
s{v}=sn;
set(findobj(t_oph,'Tag','o_t_AmplFitList'),'String',s);
o_t_TraceFcn('o_t_FitPreview_Callback');	%Refresh fit preview, if the option is checked

% --------------------------------------------------------------------
function varargout = o_t_StdFitReset_Callback(h, eventdata, handles, varargin)
global t_oph
DistrNum=eval(['0',get(findobj(t_oph,'Tag','o_t_DistrNum'),'String')]);	%Number of distributions
MinBins=-0.2;	MaxBins=1.2;	%Supposed minimal and maximal bins for possible mean positions
MeanGuessStep=(MaxBins-MinBins)/(DistrNum+1);
for i=1:DistrNum    %cycle through the distributions
    StdFitList{i}=MeanGuessStep/4;
end    %cycle through the distributions

set(findobj(t_oph,'Tag','o_t_StdFitList'),'String',StdFitList)
set(findobj(t_oph,'Tag','o_t_StdFitList'),'Value',1)
set(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String',StdFitList{1})
set(findobj(t_oph,'Tag','o_t_StdFitN'),'String','1');
% AmplGuess=1/DistrNum;

% --------------------------------------------------------------------
function varargout = o_t_StdFitAdd_Callback(h, eventdata, handles, varargin)
global t_oph
t={};
t=get(findobj(t_oph,'Tag','o_t_StdFitList'),'String');
v=get(findobj(t_oph,'Tag','o_t_StdFitList'),'Value');
for i=1:length(t)
    Bins(i)=eval(t{i});
end
Bins=[Bins([1:v-1]),(Bins(max(1,(v-1)))+Bins(min(v,end)))/2, Bins([v:end])];
t={};
for i=1:length(Bins)
    t{i}=Bins(i);
end
set(findobj(t_oph,'Tag','o_t_StdFitList'),'String',t);
set(findobj(t_oph,'Tag','o_t_StdFitList'),'Value',v);
set(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String',t{v});

% --------------------------------------------------------------------
function varargout = o_t_StdFitDelete_Callback(h, eventdata, handles, varargin)
global t_oph
t={};
t=get(findobj(t_oph,'Tag','o_t_StdFitList'),'String');
if length(t)>1
    v=get(findobj(t_oph,'Tag','o_t_StdFitList'),'Value');
    for i=1:length(t)
        Bins(i)=eval(t{i});
    end
    Bins=Bins([1:(v-1),(v+1):end]);
    t={};
    for i=1:length(Bins)
        t{i}=Bins(i);
    end
    v=max(1,(v-1));
    set(findobj(t_oph,'Tag','o_t_StdFitList'),'String',t);
    set(findobj(t_oph,'Tag','o_t_StdFitList'),'Value',v);
    set(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String',t{v});
end

% --------------------------------------------------------------------
function varargout = o_t_StdFitEdit_Callback(h, eventdata, handles, varargin)
global t_oph
s=get(findobj(t_oph,'Tag','o_t_StdFitList'),'String');
v=get(findobj(t_oph,'Tag','o_t_StdFitList'),'Value');
sn=get(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String');
s{v}=sn;
set(findobj(t_oph,'Tag','o_t_StdFitList'),'String',s);
o_t_TraceFcn('o_t_FitPreview_Callback');	%Refresh fit preview, if the option is checked

% --------------------------------------------------------------------
function varargout = o_t_MeanFitLess_Callback(h, eventdata, handles, varargin)
global t_oph
v=eval(get(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String'));
%calculate shift relative to the difference between largest and smallest positions
dv=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
dv=eval(dv{end})-eval(dv{1});
Chng=eval(get(findobj(t_oph,'Tag','o_t_MeanFitChng'),'String'));
%v=v-dv/(1+Chng/100);
v=v-Chng/100;
set(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String',num2str(v));
o_t_TraceFcn('o_t_MeanFitEdit_Callback');	%Refresh value in the list according to the "edit' field
o_t_TraceFcn('o_t_FitPreview_Callback');	%Refresh fit preview, if the option is checked

% --------------------------------------------------------------------
function varargout = o_t_AmplFitLess_Callback(h, eventdata, handles, varargin)
global t_oph
v=eval(get(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String'));
Chng=eval(get(findobj(t_oph,'Tag','o_t_AmplFitChng'),'String'));
v=v/(1+Chng/100);
set(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String',num2str(v));
o_t_TraceFcn('o_t_AmplFitEdit_Callback');	%Refresh value in the list according to the "edit' field
o_t_TraceFcn('o_t_FitPreview_Callback');	%Refresh fit preview, if the option is checked

% --------------------------------------------------------------------
function varargout = o_t_StdFitLess_Callback(h, eventdata, handles, varargin)
global t_oph
v=eval(get(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String'));
Chng=eval(get(findobj(t_oph,'Tag','o_t_StdFitChng'),'String'));
v=v/(1+Chng/100);
set(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String',num2str(v));
o_t_TraceFcn('o_t_StdFitEdit_Callback');	%Refresh value in the list according to the "edit' field
o_t_TraceFcn('o_t_FitPreview_Callback');	%Refresh fit preview, if the option is checked

% --------------------------------------------------------------------
function varargout = o_t_MeanFitMore_Callback(h, eventdata, handles, varargin)
global t_oph
v=eval(get(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String'));
Chng=eval(get(findobj(t_oph,'Tag','o_t_MeanFitChng'),'String'));
%calculate shift relative to the difference between largest and smallest positions
dv=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
dv=eval(dv{end})-eval(dv{1});
Chng=eval(get(findobj(t_oph,'Tag','o_t_MeanFitChng'),'String'));
%v=v+dv/(1+Chng/100);
v=v+Chng/100;
set(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String',num2str(v));
o_t_TraceFcn('o_t_MeanFitEdit_Callback');	%Refresh value in the list according to the "edit' field
o_t_TraceFcn('o_t_FitPreview_Callback');	%Refresh fit preview, if the option is checked

% --------------------------------------------------------------------
function varargout = o_t_AmplFitMore_Callback(h, eventdata, handles, varargin)
global t_oph
v=eval(get(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String'));
Chng=eval(get(findobj(t_oph,'Tag','o_t_AmplFitChng'),'String'));
v=v*(1+Chng/100);
set(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String',num2str(v));
o_t_TraceFcn('o_t_AmplFitEdit_Callback');	%Refresh value in the list according to the "edit' field
o_t_TraceFcn('o_t_FitPreview_Callback');	%Refresh fit preview, if the option is checked

% --------------------------------------------------------------------
function varargout = o_t_StdFitMore_Callback(h, eventdata, handles, varargin)
global t_oph
v=eval(get(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String'));
Chng=eval(get(findobj(t_oph,'Tag','o_t_StdFitChng'),'String'));
v=v*(1+Chng/100);
set(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String',num2str(v));
o_t_TraceFcn('o_t_StdFitEdit_Callback');	%Refresh value in the list according to the "edit' field
o_t_TraceFcn('o_t_FitPreview_Callback');	%Refresh fit preview, if the option is checked

% --------------------------------------------------------------------
function varargout = o_t_MeanFitChngLess_Callback(h, eventdata, handles, varargin)
global t_oph
s=eval(get(findobj(t_oph,'Tag','o_t_MeanFitChng'),'String'));
s=s/10;
set(findobj(t_oph,'Tag','o_t_MeanFitChng'),'String',num2str(s));

% --------------------------------------------------------------------
function varargout = o_t_AmplFitChngLess_Callback(h, eventdata, handles, varargin)
global t_oph
s=eval(get(findobj(t_oph,'Tag','o_t_AmplFitChng'),'String'));
s=s/10;
set(findobj(t_oph,'Tag','o_t_AmplFitChng'),'String',num2str(s));

% --------------------------------------------------------------------
function varargout = o_t_StdFitChngLess_Callback(h, eventdata, handles, varargin)
global t_oph
s=eval(get(findobj(t_oph,'Tag','o_t_StdFitChng'),'String'));
s=s/10;
set(findobj(t_oph,'Tag','o_t_StdFitChng'),'String',num2str(s));


% --------------------------------------------------------------------
function varargout = o_t_MeanFitChngMore_Callback(h, eventdata, handles, varargin)
global t_oph
s=eval(get(findobj(t_oph,'Tag','o_t_MeanFitChng'),'String'));
s=s*10;
set(findobj(t_oph,'Tag','o_t_MeanFitChng'),'String',num2str(s));

% --------------------------------------------------------------------
function varargout = o_t_AmplFitChngMore_Callback(h, eventdata, handles, varargin)
global t_oph
s=eval(get(findobj(t_oph,'Tag','o_t_AmplFitChng'),'String'));
s=s*10;
set(findobj(t_oph,'Tag','o_t_AmplFitChng'),'String',num2str(s));

% --------------------------------------------------------------------
function varargout = o_t_StdFitChngMore_Callback(h, eventdata, handles, varargin)
global t_oph
s=eval(get(findobj(t_oph,'Tag','o_t_StdFitChng'),'String'));
s=s*10;
set(findobj(t_oph,'Tag','o_t_StdFitChng'),'String',num2str(s));


% --------------------------------------------------------------------
function varargout = o_t_MeanFitList_Callback(h, eventdata, handles, varargin)
global t_oph
sm=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
sa=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'String');
ss=get(findobj(t_oph,'Tag','o_t_StdFitList'),'String');
v=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value');
set(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String',sm{v});
set(findobj(t_oph,'Tag','o_t_MeanFitN'),'String',num2str(v));
if length(sa)==length(sm)	%lists of equal length
	set(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value',v);
	set(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String',sa{v});
	set(findobj(t_oph,'Tag','o_t_AmplFitN'),'String',num2str(v));
end	%lists of equal length
if length(ss)==length(sm)	%lists of equal length
	set(findobj(t_oph,'Tag','o_t_StdFitList'),'Value',v);
	set(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String',ss{v});
	set(findobj(t_oph,'Tag','o_t_StdFitN'),'String',num2str(v));
end	%lists of equal length


% --------------------------------------------------------------------
function varargout = o_t_AmplFitList_Callback(h, eventdata, handles, varargin)
global t_oph
sm=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
sa=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'String');
ss=get(findobj(t_oph,'Tag','o_t_StdFitList'),'String');
v=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value');
set(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String',sa{v});
set(findobj(t_oph,'Tag','o_t_AmplFitN'),'String',num2str(v));
if length(sm)==length(sa)	%lists of equal length
	set(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value',v);
	set(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String',sm{v});
	set(findobj(t_oph,'Tag','o_t_MeanFitN'),'String',num2str(v));
end	%lists of equal length
if length(ss)==length(sa)	%lists of equal length
	set(findobj(t_oph,'Tag','o_t_StdFitList'),'Value',v);
	set(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String',ss{v});
	set(findobj(t_oph,'Tag','o_t_StdFitN'),'String',num2str(v));
end	%lists of equal length

% --------------------------------------------------------------------
function varargout = o_t_StdFitList_Callback(h, eventdata, handles, varargin)
global t_oph
sm=get(findobj(t_oph,'Tag','o_t_MeanFitList'),'String');
sa=get(findobj(t_oph,'Tag','o_t_AmplFitList'),'String');
ss=get(findobj(t_oph,'Tag','o_t_StdFitList'),'String');
v=get(findobj(t_oph,'Tag','o_t_StdFitList'),'Value');
set(findobj(t_oph,'Tag','o_t_StdFitEdit'),'String',ss{v});
set(findobj(t_oph,'Tag','o_t_StdFitN'),'String',num2str(v));
if length(sm)==length(ss)	%lists of equal length
	set(findobj(t_oph,'Tag','o_t_MeanFitList'),'Value',v);
	set(findobj(t_oph,'Tag','o_t_MeanFitEdit'),'String',sm{v});
	set(findobj(t_oph,'Tag','o_t_MeanFitN'),'String',num2str(v));
end	%lists of equal length
if length(sa)==length(ss)	%lists of equal length
	set(findobj(t_oph,'Tag','o_t_AmplFitList'),'Value',v);
	set(findobj(t_oph,'Tag','o_t_AmplFitEdit'),'String',sa{v});
	set(findobj(t_oph,'Tag','o_t_AmplFitN'),'String',num2str(v));
end	%lists of equal length

function	Out=inf2range(A,B,In)

%Inputs:
%A - lower boundary
%B - upper boundary
%In - value from 0 to Inf

%Outputs:
%Out - value in the range

Out=A+(B-A)*(1./(1+exp(-In)));
