%hstsave - function for hystogram saving
function [HstS,BinsX,BinsY,BinsZ]=swtchtmhstopen(FileName);	%open histogram file function
%Outputs:
%HstS -	Histogram data file
%BinsX -	X bins' boundaries vector.
%BinsY -	Y bins' boundaries vector.
%BinsZ -	Z bins' boundaries vector.

%Input:
%FileName -	Filename template

%global HstS
%HstS=[];	%clearing HstS

fh=fopen([FileName,'.txs']);

t=fgets(fh);	%Reading text file header
lnXY=sscanf(t,'%g %g %g');	%Bins vectors dimensions
%lnXY=round(lnXY);

HstS.up=zeros((lnXY(1)-1),(lnXY(2)-1),(lnXY(3)-1));	%Histogram matrix reserving
HstS.down=HstS.up;

for i=1:lnXY(1)	%Reading X bins values
    t=fgets(fh);
    BinsX(i)=sscanf(t,'%g');
end

for i=1:lnXY(2)	%Reading Y bins values
    t=fgets(fh);
    BinsY(i)=sscanf(t,'%g');
end

for i=1:lnXY(3)	%Reading Z bins values
    t=fgets(fh);
    BinsZ(i)=sscanf(t,'%g');
end

for h=1:(lnXY(3)-1)
	for i=1:(lnXY(1)-1)
		t=fgets(fh);
		HRow=sscanf(t,'%g');
		HstS.up(i,:,h)=HRow';
	end
end

for h=1:(lnXY(3)-1)
	for i=1:(lnXY(1)-1)
		t=fgets(fh);
		HRow=sscanf(t,'%g');
		HstS.down(i,:,h)=HRow';
	end
end

fclose(fh);