%tracehst - function for creation 1D histogram from the part of 2D histogram
function [HstT, BinsXT, BinsYT, BinsZT]=swtchtmtracehst(Hst,BinsX,MinX,MaxX,AutoX,BinsY,MinY,MaxY,AutoY,BinsZ,MinZ,MaxZ,AutoZ,Dimn,NormN)

%Outputs:
%HstT	-	traced 1D histogram vector
%BinsXT, BinsYT, BinsZT -	bins vectors for 3D histogam. If dimension is not used vector is empty - []

%Inputs:
%Hst -	2D histogram data matrix
%BinsX -	bins for X axis
%MinX -	minimal X axis value for the trace range
%MaxX -	maximal X axis value for the trace range
%AutoX -	Autoselect minimal and maximal values from the full axis range
%BinsY -	bins for Y axis
%MinY -	minimal Y axis value for the trace range
%MaxY -	maximal Y axis value for the trace range
%AutoY -	Autoselect minimal and maximal values from the full axis range
%Dimn -	dimension to go along (other dimension will be summarized) <1> or<2>
%NormN -	flag for normalizing values in histogram relative to the total amount of points - <1*> or <0>

%Initialize output bins vectors
BinsXT=[];
BinsYT=[];
BinsZT=[];

if AutoX==1	%Autoselect minimal and maximal values from the full axis range
	NMinX=1;NMaxX=length(BinsX);
else
	Nmbs=find((BinsX>=MinX)&(BinsX<=MaxX));	%Bins boundaries fitting in the range
	NMinX=min(Nmbs);
	NMaxX=max(Nmbs);
end

if AutoY==1	%Autoselect minimal and maximal values from the full axis range
	NMinY=1;NMaxY=length(BinsY);
else
	Nmbs=find((BinsY>=MinY)&(BinsY<=MaxY));	%Bins boundaries fitting in the range
	NMinY=min(Nmbs);
	NMaxY=max(Nmbs);
end

if AutoZ==1	%Autoselect minimal and maximal values from the full axis range
	NMinZ=1;NMaxZ=length(BinsZ);
else
	Nmbs=find((BinsZ>=MinZ)&(BinsZ<=MaxZ));	%Bins boundaries fitting in the range
	NMinZ=min(Nmbs);
	NMaxZ=max(Nmbs);
end

HstT=[];
switch Dimn	%Dimension(s) anlong whish tracin is going 'XY up','XZ up','YZ up','X up','Y up','Z up','XY down','XZ down','YZ down','X down','Y down','Z down'
case 1	%'XY up'
	%     BinsT=BinsX(NMinX:NMaxX);
	%     for i=NMinX:(NMaxX-1)
	% 	switch NormN    %Mode of trace normalizing
	% 	case {1,2,3,9} 
	% 	    %case 1 'Z Absolute'
	% 	    %case 2  %'Z/(Trc pnts)' normalizing values in histogram relative to the total amount of points in trace histogram
	% 	    %case 3   %'Z/(Trc max)' normalizing values in histogram relative to the maximum amount of points in trace histogram
	% 	    %case 9   %'Z/(All pnts)'
	% 	    HstT(end+1)=sum(Hst(i,NMinY:(NMaxY-1)));
	% 	case {4,5,6}    
	% 	    %case 4  %'Z*Val'
	% 	    %case 5  %'Z*Val/(Trc pnts)'
	% 	    %case 6  %'Z*Val/(Trc max)'
	% 	    j=NMinY:(NMaxY-1);
	% 	    HstT(end+1)=sum(Hst(i,j).*(BinsY(j)+BinsY(j+1))/2);	%Multiplying value probability on it's magnitude
	% 	case 7  %'Z*Val/(Drn pnts)'
	% 	    j=NMinY:(NMaxY-1);
	% 	    HstT(end+1)=sum(Hst(i,j).*(BinsY(j)+BinsY(j+1))/2)/sum(Hst(i,:));	%Multiplying value probability on it's magnitude and dividing on all points number in this bin
	% 	case 8   %'Z/(Drn pnts)'
	% 	    j=NMinY:(NMaxY-1);
	% 	    if sum(Hst(i,:)) ~= 0
	% 		HstT(end+1)=sum(Hst(i,j))/sum(Hst(i,:));	%Dividing on all points number in this bin
	% 	    else
	% 		HstT(end+1)=0;
	% 	    end
	% 	end
	%     end
case 2 %'XZ up'
	BinsXT=BinsX(NMinX:NMaxX);
	BinsZT=BinsZ(NMinZ:NMaxZ);
	for j=NMinZ:(NMaxZ-1)
		for i=NMinX:(NMaxX-1)
			switch NormN    %Mode of trace normalizing
			case {1,2,3,9} 
				%case 1 'Z Absolute'
				%case 2  %'Z/(Trc pnts)' normalizing values in histogram relative to the total amount of points in trace histogram
				%case 3   %'Z/(Trc max)' normalizing values in histogram relative to the maximum amount of points in trace histogram
				%case 9   %'Z/(All pnts)'
				HstT((i-NMinX+1),(j-NMinZ+1))=sum(Hst.up(i,NMinY:(NMaxY-1),j));
			case {4,5,6}    
				% 		%case 4  %'Z*Val'
				% 		%case 5  %'Z*Val/(Trc pnts)'
				% 		%case 6  %'Z*Val/(Trc max)'
				% 		j=NMinX:(NMaxX-1);
				% 		HstT(end+1)=sum(Hst(j,i)'.*(BinsX(j)+BinsX(j+1))/2);	%Multiplying value probability on it's magnitude
			case 7  %'Z*Val/(Drn pnts)'
				% 		j=NMinX:(NMaxX-1);
				% 		if sum(Hst(:,i)) ~= 0
				% 		    HstT(end+1)=sum(Hst(j,i)'.*(BinsX(j)+BinsX(j+1))/2)/sum(Hst(:,i));	%Multiplying value probability on it's magnitude and dividing on all points number in this bin
				% 		else
				% 		    HstT(end+1)=0;
				% 		end
			case 8   %'Z/(Drn pnts)'
				% 		j=NMinX:(NMaxX-1);
				% 		HstT(end+1)=sum(Hst(j,i))/sum(Hst(:,i));	%Dividing on all points number in this bin
			end    
		end
	end
case 3	%'YZ up'
case 4	%'X up'
case 5	%'Y up'
case 6	%'Z up'
case 7	%'XY down'
case 8	%'XZ down'
	BinsXT=BinsX(NMinX:NMaxX);
	BinsZT=BinsZ(NMinZ:NMaxZ);
	for j=NMinZ:(NMaxZ-1)
		for i=NMinX:(NMaxX-1)
			switch NormN    %Mode of trace normalizing
			case {1,2,3,9} 
				%case 1 'Z Absolute'
				%case 2  %'Z/(Trc pnts)' normalizing values in histogram relative to the total amount of points in trace histogram
				%case 3   %'Z/(Trc max)' normalizing values in histogram relative to the maximum amount of points in trace histogram
				%case 9   %'Z/(All pnts)'
				HstT((i-NMinX+1),(j-NMinZ+1))=sum(Hst.down(i,NMinY:(NMaxY-1),j));
			case {4,5,6}    
				% 		%case 4  %'Z*Val'
				% 		%case 5  %'Z*Val/(Trc pnts)'
				% 		%case 6  %'Z*Val/(Trc max)'
				% 		j=NMinX:(NMaxX-1);
				% 		HstT(end+1)=sum(Hst(j,i)'.*(BinsX(j)+BinsX(j+1))/2);	%Multiplying value probability on it's magnitude
			case 7  %'Z*Val/(Drn pnts)'
				% 		j=NMinX:(NMaxX-1);
				% 		if sum(Hst(:,i)) ~= 0
				% 		    HstT(end+1)=sum(Hst(j,i)'.*(BinsX(j)+BinsX(j+1))/2)/sum(Hst(:,i));	%Multiplying value probability on it's magnitude and dividing on all points number in this bin
				% 		else
				% 		    HstT(end+1)=0;
				% 		end
			case 8   %'Z/(Drn pnts)'
				% 		j=NMinX:(NMaxX-1);
				% 		HstT(end+1)=sum(Hst(j,i))/sum(Hst(:,i));	%Dividing on all points number in this bin
			end    
		end
	end
case 9	%'YZ down'
case 10	%'X down'
case 11	%'Y down'
case 12	%'Z down'
end
%size(HstT)%!
%sum(HstT)%!

%s=(BinsT(end)-BinsT(1))/(length(BinsT)-1);
%for i=1:(length(BinsT)-1)
%   d=(BinsT(i+1)-BinsT(i))/s;
%   HstT(i)=HstT(i)/d;
%end

switch NormN    %Mode of trace normalizing
case {1,4,7,8}
	%case 1  %'Z Absolute'
	%case 4  %'Z*Val'
	%case 7  %'Z*Val/(Drn pnts)'
	%case 8   %'Z/(Drn pnts)'
case {2,5}
	%     %case 2  %'Z/(Trc pnts)' normalizing values in histogram relative to the total amount of points in trace histogram
	%     %case 5  %'Z*Val/(Trc pnts)'
	%     HstT=HstT/sum(HstT);
case {3,6}   
	%     %case 3   %'Z/(Trc max)' normalizing values in histogram relative to the maximum amount of points in trace histogram
	%     %case 6  %'Z*Val/(Trc max)'
	%     HstT=HstT/max(HstT);
case 9   %'Z/(All pnts)'
	%     HstT=HstT/sum(sum(Hst));
end
